libstdc++: __gnu_pbds::list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc > Class Template Reference

libstdc++

__gnu_pbds::list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc > Class Template Reference
Extensions » Policy-Based Data Structures » Containers » List-Based

`#include <assoc_container.hpp>`

## Public Types
typedef list_update_tag | container_category
typedef Eq_Fn | eq_fn
typedef Update_Policy | update_policy

## Public Member Functions
| list_update (const list_update &other)
template<typename It>
| list_update (It first, It last)
list_update & | operator= (const list_update &other)
void | swap (list_update &other)

## Detailed Description

template<typename Key, typename Mapped, class Eq_Fn = typename detail::default_eq_fn<Key>::type, class Update_Policy = detail::default_update_policy::type, class _Alloc = std::allocator<char>>
class __gnu_pbds::list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc >

A list-update based associative container.

Template Parameters

  Key | Key type.
  Mapped | Map type.
  Eq_Fn | Equal functor.
  Update_Policy | Update policy, determines when an element will be moved to the front of the list.
  _Alloc | Allocator type.

Base is detail::lu_map.

Definition at line 815 of file assoc_container.hpp.

## Member Typedef Documentation

## ◆ container_category

template<typename Key, typename Mapped, class Eq_Fn = typename detail::default_eq_fn<Key>::type, class Update_Policy = detail::default_update_policy::type, class _Alloc = std::allocator<char>>

typedef list_update_tag __gnu_pbds::list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc >::container_category

Definition at line 821 of file assoc_container.hpp.

## ◆ eq_fn

template<typename Key, typename Mapped, class Eq_Fn = typename detail::default_eq_fn<Key>::type, class Update_Policy = detail::default_update_policy::type, class _Alloc = std::allocator<char>>

typedef Eq_Fn __gnu_pbds::list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc >::eq_fn

Definition at line 822 of file assoc_container.hpp.

## ◆ update_policy

template<typename Key, typename Mapped, class Eq_Fn = typename detail::default_eq_fn<Key>::type, class Update_Policy = detail::default_update_policy::type, class _Alloc = std::allocator<char>>

typedef Update_Policy __gnu_pbds::list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc >::update_policy

Definition at line 823 of file assoc_container.hpp.

## Constructor & Destructor Documentation

## ◆ list_update() [1/3]

template<typename Key, typename Mapped, class Eq_Fn = typename detail::default_eq_fn<Key>::type, class Update_Policy = detail::default_update_policy::type, class _Alloc = std::allocator<char>>

__gnu_pbds::list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc >::list_update | ( |  | ) |
| inline

Definition at line 825 of file assoc_container.hpp.

## ◆ list_update() [2/3]

template<typename Key, typename Mapped, class Eq_Fn = typename detail::default_eq_fn<Key>::type, class Update_Policy = detail::default_update_policy::type, class _Alloc = std::allocator<char>>
template<typename It>

__gnu_pbds::list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc >::list_update | ( | It | first,
|  | It | last )
| inline

Constructor taking __iterators to a range of value_types. The value_types between first_it and last_it will be inserted into the container object.

Definition at line 831 of file assoc_container.hpp.

## ◆ list_update() [3/3]

template<typename Key, typename Mapped, class Eq_Fn = typename detail::default_eq_fn<Key>::type, class Update_Policy = detail::default_update_policy::type, class _Alloc = std::allocator<char>>

__gnu_pbds::list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc >::list_update | ( | const list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc > & | other | ) |
| inline

Definition at line 834 of file assoc_container.hpp.

## ◆ ~list_update()

template<typename Key, typename Mapped, class Eq_Fn = typename detail::default_eq_fn<Key>::type, class Update_Policy = detail::default_update_policy::type, class _Alloc = std::allocator<char>>

virtual __gnu_pbds::list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc >::~list_update | ( |  | ) |
| inlinevirtual

Definition at line 838 of file assoc_container.hpp.

## Member Function Documentation

## ◆ operator=()

template<typename Key, typename Mapped, class Eq_Fn = typename detail::default_eq_fn<Key>::type, class Update_Policy = detail::default_update_policy::type, class _Alloc = std::allocator<char>>

list_update & __gnu_pbds::list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc >::operator= | ( | const list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc > & | other | ) |
| inline

Definition at line 841 of file assoc_container.hpp.

## ◆ swap()

template<typename Key, typename Mapped, class Eq_Fn = typename detail::default_eq_fn<Key>::type, class Update_Policy = detail::default_update_policy::type, class _Alloc = std::allocator<char>>

void __gnu_pbds::list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc >::swap | ( | list_update< Key, Mapped, Eq_Fn, Update_Policy, _Alloc > & | other | ) |
| inline

Definition at line 852 of file assoc_container.hpp.

The documentation for this class was generated from the following file:

- assoc_container.hpp